import { CountDocumentsOptions, Filter, UpdateFilter, UpdateOptions, UpdateResult } from 'mongodb';
import { MongoCollection, MongoCollectionOptions, MongoDatabase, MongoDocument } from './mongodb';
import { LockOptions } from './types';
export declare class Collection<TEntity extends MongoDocument> extends MongoCollection<TEntity> {
    constructor(db: MongoDatabase, name?: string, options?: MongoCollectionOptions);
    countDocuments(filter?: Filter<TEntity>, options?: CountDocumentsOptions): Promise<number>;
    upsert(filter: Filter<TEntity>, update: UpdateFilter<TEntity> | Partial<TEntity>, options?: UpdateOptions | undefined): Promise<UpdateResult<TEntity>>;
    withDocumentLock<TReturn>(options: LockOptions<TEntity, TReturn>): Promise<Awaited<TReturn>>;
    private lock;
    private unlock;
    private unlockWithResult;
}
